let gulp         = require('gulp');
let gulpFilter   = require('gulp-filter');
let uglify       = require('oa-laravel-elixir-js-uglify');
let elixir       = require('laravel-elixir');
let gutil = require('gulp-util');
const path = require('path');
const fs = require('fs');

/**
 * Compile javascript files, useful when using scripts loaded asynchronously
 * @param  {string}        src        The files to uglify
 * @param  {string|object} outputPath The output path, or an options object
 * @param  {string|object} baseDir    The dir in wich to look for js files, or an options object
 * @param  {object}        options    The options object passed to the uglify task
 * @param  {array}         myPathsToBeVersioned    The paths to be versioned
 */
elixir.extend('oajs', function (src, output,myPathsToBeVersioned) {
    let config       = elixir.config;
    var dir = path.dirname(output);
    var fileName = output.replace(/\\/g, '/').substring(output.lastIndexOf('/') + 1, output.lastIndexOf('.'));

    myPathsToBeVersioned.push("public/" + dir + "/" + fileName + ".min.js");

    elixir(function (mix) {
        if (elixir.config.production) {
            mix.combine(src, "public/" + output);
            mix.uglify(fileName, 'public/' + dir, 'public/' + dir);

        } else {
            mix.scripts(src, "public/" + output);
            mix.rename("public/" + dir + "/" + fileName + ".js.map", fileName + '.min.js.map', "public/" + dir);


        }
        mix.rename("public/" + dir + "/" + fileName + ".js", fileName + '.min.js', "public/" + dir);

    });
});
